/************************************************************************************
 *
 *   file name   : func_timer6.c
 *   Contents    : Timer X (pulse output mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit5 = ICON1.5;
bit ICON1_bit7 = ICON1.7;
bit P1D_4	   = P1D.4;
bit TXM_bit3   = TXM.3;

/*==================================================================================*/

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		char f_REQ_BUZZ=1;

		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();		/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;      /*; Timer1 interrupt disable */
		IREQ2_bit5	= 0;      /*; Timer1 interrupt request clear */
		TCSS2		= 0x02;   /*; Set Timer count source set register 2 */
		PRE1		= 200-1;  /*; Set Prescaler 1 */
		T1		= 100-1;  /*; Set Timer 1 */
		IREQ2_bit5	= 0;      /*; Timer1 interrupt request clear */
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}  /*; 10ms? */
		
		CPUM = 0xC0;              /*; Set CPU mode register */
		
		/***   main program   ***/
		ICON1_bit5		= 0;	/* disable CNTR0 interrupt */
		ICON1_bit7		= 0;	/* disable timer X interrupt */
		
		P1D			= 0x10; /* P1.4 = output */
		P1_4 			= 1;
		
		TXM			= 0x09;	/* pulse output mode */
												/* first outpu signal level : H level */
												/* stop timer X count */

		TCSS1			= 0x01;	/* select timer X count source : f(XIN)/2 */
		
		PREX			= 0x01;	/* set prescaler X */
		TX			= 0x7C; /* set timer X */
		
		while(1){
			if(f_REQ_BUZZ != 1){	/* occur request buzzer output ? */
				if(TXM_bit3 == 0){	/* detect timer X stop */
					TXM_bit3 = 1;	/* stop timer X count */
					PREX = 0x01;	/* set prescaler X */
					TX = 0x7C;	/* set timer X */
				}
			}
			else{
				if(TXM_bit3 == 1){	/* detect timer X operating */
					TXM_bit3 = 0;	/* start timer X mode */
				}
			}
			
			/* process */
			
		}

}

/************************************************************************************/
